#include <stm32f0xx.h>

#include <callback.hpp>
using namespace stm32f072xb;

/*--------------------------------------------------------------------------------------------------*/
// SETUP
/*--------------------------------------------------------------------------------------------------*/

void ledBlinkCallBack(void*) {
	if (READ_BIT(GPIOA->IDR, GPIO_ODR_5)) {  // read button p.159)
		CLEAR_BIT(GPIOA->ODR, GPIO_ODR_5);   // turn off LED, p.159
	} else {
		SET_BIT(GPIOA->ODR, GPIO_ODR_5);  // turn on LED, p.159
	}
}

/*--------------------------------------------------------------------------------------------------*/
// COMMON SETUP
/*--------------------------------------------------------------------------------------------------*/

void setupLed() {
	// LED
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOAEN);  // enable GPIOA (p.120)
	CLEAR_BIT(GPIOA->MODER, GPIO_MODER_MODER5);
	SET_BIT(GPIOA->MODER, GPIO_MODER_MODER5_0);  // Output mode (p.157)
	CLEAR_BIT(GPIOA->OTYPER, GPIO_OTYPER_OT_5);  // Push-pull output (p.157)
}

/*--------------------------------------------------------------------------------------------------*/
// MAIN
/*--------------------------------------------------------------------------------------------------*/

int main() {
	setupLed();

	// do not delete callback object, otherwise timer will stop
	TimerInterruptCallback callback = TimerInterruptCallback(ledBlinkCallBack, 4);

	// 8 000 000 / 65 535 = 122.07 cycles
	callback.start(122, 0xFFFF);

	while (true) {
	}

	return 0;
}
